/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright (c) 2007 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU Lesser
 * General Public License Version 2.1 only ("LGPL") or the Common Development and
 * Distribution License ("CDDL")(collectively, the "License"). You may not use this
 * file except in compliance with the License. You can obtain a copy of the CDDL at
 * http://www.opensource.org/licenses/cddl1.php and a copy of the LGPLv2.1 at
 * http://www.opensource.org/licenses/lgpl-license.php. See the License for the 
 * specific language governing permissions and limitations under the License. When
 * distributing the software, include this License Header Notice in each file and
 * include the full text of the License in the License file as well as the
 * following notice:
 * 
 * NOTICE PURSUANT TO SECTION 9 OF THE COMMON DEVELOPMENT AND DISTRIBUTION LICENSE
 * (CDDL)
 * For Covered Software in this distribution, this License shall be governed by the
 * laws of the State of California (excluding conflict-of-law provisions).
 * Any litigation relating to this License shall be subject to the jurisdiction of
 * the Federal Courts of the Northern District of California and the state courts
 * of the State of California, with venue lying in Santa Clara County, California.
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or only
 * the LGPL Version 2.1, indicate your decision by adding "[Contributor]" elects to
 * include this software in this distribution under the [CDDL or LGPL Version 2.1]
 * license." If you don't indicate a single choice of license, a recipient has the
 * option to distribute your version of this file under either the CDDL or the LGPL
 * Version 2.1, or to extend the choice of license to its licensees as provided
 * above. However, if you add LGPL Version 2.1 code and therefore, elected the LGPL
 * Version 2 license, then the option applies only if the new code is made subject
 * to such option by the copyright holder. 
 */

#ifndef _IMI_OPTIONS_H
#define _IMI_OPTIONS_H

#include "portability.h"

class CIMIOptions {
public:
    virtual ~CIMIOptions();

    virtual CIMIOptions* clone() const = 0;

    virtual bool operator==(const CIMIOptions* p2) const = 0;

    virtual bool copy(const CIMIOptions* p2) = 0;
};

class CSunpinyinOptions :  public CIMIOptions {

public:
    virtual ~CSunpinyinOptions();

    virtual CIMIOptions* clone() const;

    virtual bool operator==(const CIMIOptions* p2) const;

    virtual bool copy(const CIMIOptions* p2);

public:
    int         m_ViewType;
    int         m_GBK;
    int         m_MinusAsPageUp;
    int         m_CommaAsPageUp;
    int         m_BracketAsPageUp;

    int         m_MemoryPower;
    int         m_ContextRanking;
    int         m_LayoutVeritcal;
    int         m_Fuzzy;
    int         m_Fuzzy_zh;
    int         m_Fuzzy_ch;
    int         m_Fuzzy_sh;
    int         m_Fuzzy_ln;
    int         m_Fuzzy_fh;
    int         m_Fuzzy_ang;
    int         m_Fuzzy_eng;
    int         m_Fuzzy_ing;
    
    int         m_CandiWindowSize;

public:
    CSunpinyinOptions();

    bool        isPageUpKey(unsigned keycode, unsigned keychar, unsigned mask);
    bool        isPageDnKey(unsigned keycode, unsigned keychar, unsigned mask);
};

#endif
